import { getToken } from "../tokenFuctionality";

export const  Helper =  async ({url, body , method ,signal, hasToken=true , params})=>{
    try {
        const urlWithParams = new URL(url);
        urlWithParams.search = new URLSearchParams(params).toString();
        const data = {
            method :method,
            // withCredentials: true,
            credentials: 'include',
            // mode: "no-cors",
            headers:hasToken?{
                "Content-Type": 'application/json',
                // "Access-Control-Allow-Credentials":"true",
                // "Access-Control-Allow-Origin":"*",
                // "Access-Control-Allow-Methods":"GET,DELETE,PATCH,POST,PUT" ,
                // "Access-Control-Allow-Headers":"X-CSRF-Token, X-Requested-With, Accept, Accept-Version, Content-Length, Content-MD5, Content-Type, Date, X-Api-Version",
                "Authorization" :`Bearer ${getToken()}`
            }:{},
            cache: "force-cache",
            
        }
        if(signal)
            data["signal"]  = signal
        if(method == "POST")
            data["body"] = JSON.stringify(body)
        const result = await fetch(urlWithParams,data)
        const response = await result.json()
        if(response.status == "401"){
            if(window.location.pathname != "/login")
                // window.location.href = "/login"
            return {message : response.message}
        }
        if(response.status == "500")
            return{ message :"Something error please try again ."}
        if(response.status == "422")
            return{ message :response.message}
        return {response ,message : response.message}
    }catch (error){
        if (error.message === '404 Not Found') {
            console.error('Error: Resource not found');
            return {message :"Resource not found"}
          } else if (error.message === '500 Internal Server Error') {
            console.error('Error: Internal server error');
            return { message :"Somthing error please try again ."}
          } else if(error.message=="signal is aborted without reason"){
            return { message :"signal is aborted without reason"}
          }else {
            console.error('There has been a problem with your fetch operation:', error);
            return { message :"error"}
          }
    }

}